#include "frameBuffer.h"

#include "FL/gl.h"
#include <iostream.h>

#include "globals.h"
#include <math.h>
#include <float.h>

#include <tiffio.h>
#include <fstream.h>


FrameBuffer::FrameBuffer(int u0, int v0, int _w, int _h) : 
  w(_w), h(_h), Fl_Gl_Window(u0, v0, _w, _h, 0) {

  pix = new unsigned int[w*h];

}

void FrameBuffer::draw() {

  if (pix)
    glDrawPixels(w, h, GL_RGBA, GL_UNSIGNED_BYTE, pix);
  else
    cerr << "attempted to post bad pixels in FrameBuffer::PostSWFB()" << endl;

}

void FrameBuffer::show() {

  if (pix)
    size(w, h);
  Fl_Gl_Window::show();
  
}

int FrameBuffer::handle(int event) {

  switch (event) {
  case FL_RELEASE: {
    int mouseu = Fl::event_x();
    int mousev = Fl::event_y();
    cerr << "INFO: released mouse button at: " << 
      mouseu << " " << mousev << endl;
    break;
  }
  case FL_MOVE: {
    break;
  }
  case FL_KEYBOARD: {
    int key = Fl::event_key();
    cerr << "INFO: pressed: " << (char) key << endl;
    break;
  }
  default: {
    // events I don't handle
  }
  }

  return 1;

}

void FrameBuffer::Set(int u, int v, unsigned int color) {

  pix[(h-1-v)*w+u] = color;

}

void FrameBuffer::Clear(unsigned int clearColor) {

  for (int v = 0; v < h; v++) {
    for (int u = 0; u < w; u++) {
      Set(u, v, clearColor);
    }
  }

}

void FrameBuffer::MakeChecker(int checkerWidth, unsigned int *colors) {

  for (int v = 0; v < h; v++) {
    for (int u = 0; u < w; u++) {
      unsigned int currColor = colors[0];
      int cu = u/checkerWidth;
      int cv = v/checkerWidth;
      if ((cu+cv)%2) {
        currColor = colors[1];
      }
      Set(u, v, currColor);
    }
  }


}
